window.Gleam.initSearch([{"doc":"aws4_request","title":"aws4_request","content":"# aws4_request\n\nAn AWS Signature Version 4 client implementation, useful for making\nauthenticated requests to services such as AWS S3.\n\n[![Package Version](https://img.shields.io/hexpm/v/aws4_request)](https://hex.pm/packages/aws4_request)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/aws4_request/)\n\n```sh\ngleam add aws4_request\n```\n```gleam\nimport gleam/httpc\nimport aws4_request\nimport gleam/http/request\n\npub fn main() {\n  let access_key_id = &quot;AKIDEXAMPLE&quot;\n  let secret_access_key = &quot;wJalrXUtnFEMI/K7MDENG+bPxRfiCYEXAMPLEKEY&quot;\n  let region = &quot;us-east-1&quot;\n  let service = &quot;iam&quot;\n  let date_time = #(#(2015, 8, 30), #(12, 36, 0))\n  let assert Ok(request) =\n    request.to(&quot;https://iam.amazonaws.com/?Action=ListUsers&amp;Version=2010-05-08&quot;)\n  let request = request.Request(..request, headers: [\n    #(&quot;host&quot;, &quot;iam.amazonaws.com&quot;),\n    #(&quot;content-type&quot;, &quot;application/x-www-form-urlencoded; charset=utf-8&quot;),\n  ])\n  let request =\n    request\n    |&gt; request.set_method(http.Get)\n    |&gt; request.set_body(&lt;&lt;&gt;&gt;)\n\n  let signed_request =\n    aws4_request.sign(\n      request,\n      date_time,\n      access_key_id,\n      secret_access_key,\n      region,\n      service,\n    )\n\n  // Now send the signed request with a HTTP client\n  httpc.send(signed_request)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/buckets&gt;.\n","url":"index.html"},{"doc":"aws4_request","title":"sign","content":"pub fn sign(\n  request request: Request(BitArray),\n  date_time date_time: #(#(Int, Int, Int), #(Int, Int, Int)),\n  access_key_id access_key_id: String,\n  secret_access_key secret_access_key: String,\n  region region: String,\n  service service: String,\n) -&gt; Request(BitArray)\n\nSynonyms:\naws4_request.sign\naws4_request sign","url":"aws4_request.html#sign"},{"doc":"aws4_request","title":"aws4_request","content":"","url":"aws4_request.html"}]);